freeslot("MT_BADGDICE", "SPR_BCMD", "S_BADGDICE", "sfx_whspc7") -- DICE
freeslot("MT_BADGDROP") -- drop
freeslot("MT_BADGENG", "SPR_BCMEA0", "S_BADGENG") -- ENERGY
freeslot("MT_BADGDRAFT", "SPR_BCMSA0", "SPR_BCMSB0", "SPR_BCMSC0", "SPR_BCMSD0",
"SPR_BCMSE0", "SPR_BCMSF0", "SPR_BCMSG0", "S_BADGDRFT") -- DRAFT


-- STATES

-- DICE ANIM
states[S_BADGDICE] = {SPR_BCMD, FF_ANIMATE|FF_GLOBALANIM|A, -1, nil, 5, 3, S_NULL}
-- states[S_BADGDICE2] = {SPR_BCMD, B, 8, nil, 0, 0, S_BADGDICE3}
-- states[S_BADGDICE3] = {SPR_BCMD, C, 8, nil, 0, 0, S_BADGDICE4}
-- states[S_BADGDICE4] = {SPR_BCMD, D, 8, nil, 0, 0, S_BADGDICE5}
-- states[S_BADGDICE5] = {SPR_BCMD, E, 8, nil, 0, 0, S_BADGDICE6}
-- states[S_BADGDICE6] = {SPR_BCMD, F, 8, nil, 0, 0, S_BADGDICE1}

states[S_BADGENG] = {
	sprite = SPR_BCMEA0,
	frame = A,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_BADGDRFT] = {
	sprite = SPR_BCMSA0,
	frame = A,
	tics = -1,
	action = nil,
	var1 = 0,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

-- OBJECTS
mobjinfo[MT_BADGDICE] = {
	doomednum = 5600, -- UDMF metadata
	--$Name DoAE dice
	--$Sprite BCMDA0
	--$StringArg0 Color type
	spawnstate = S_BADGDICE,
	deathstate = S_INVISIBLE,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

mobjinfo[MT_BADGDROP] = {
	doomednum = -1,
	spawnstate = S_BADGDICE,
	deathstate = S_NULL,
	speed = 20,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SPECIAL
}

mobjinfo[MT_BADGENG] = {
	doomednum = 5601, -- UDMF metadata
	--$Name DoAE Energy
	--$Sprite SPR_BCMEA0
	spawnstate = S_BADGENG,
	deathstate = S_INVISIBLE,
	radius = 32*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

mobjinfo[MT_BADGDRAFT] = {
	doomednum = 5602,
	spawnstate = S_BADGDRFT,
	deathstate = S_NULL,
	radius = 24*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

-- Dice spawn func
addHook("MapThingSpawn", function(mobj, thing)
	mobj.z = $+4*FRACUNIT
	mobj.DoAEdice_color = thing.stringargs[0]
end, MT_BADGDICE)

-- droppable dice spawn func
addHook("MobjSpawn", function(mobj)
	-- init values at spawn
	mobj.fuse = TICRATE*12;
	mobj.scale = $*2;
	mobj.momz = FRACUNIT*2;
	

	-- Grant color depending of timing
	if leveltime%4 == 0 mobj.DoAEdice_color = "red";
	elseif leveltime%4 == 1 mobj.DoAEdice_color = "silver";
	elseif leveltime%4 == 2 mobj.DoAEdice_color = "green";
	elseif leveltime%4 == 3 mobj.DoAEdice_color = "blue";
	end
end, MT_BADGDROP)
